Package org.springframework.transaction.reactive

# Class ReactiveResourceSynchronization<O,K>

java.lang.Object
org.springframework.transaction.reactive.ReactiveResourceSynchronization<O,K>

Type Parameters:
  `O` - the resource holder type
  `K` - the resource key type

All Implemented Interfaces:
  `TransactionSynchronization`

public abstract class ReactiveResourceSynchronization<O,K> extends Object implements TransactionSynchronization
`TransactionSynchronization` implementation that manages a resource object bound through `TransactionSynchronizationManager`.

Since:
  5.2
Author:
  Mark Paluch, Juergen Hoeller

## Field Summary

### Fields inherited from interface org.springframework.transaction.reactive.TransactionSynchronization

`STATUS_COMMITTED, STATUS_ROLLED_BACK, STATUS_UNKNOWN`

## Constructor Summary

Constructors
Constructor
Description
`ReactiveResourceSynchronization(O resourceObject, K resourceKey, TransactionSynchronizationManager synchronizationManager)`
Create a new ReactiveResourceSynchronization for the given holder.

## Method Summary

Modifier and Type
Method
Description
`reactor.core.publisher.Mono<Void>`
`afterCommit()`
Invoked after transaction commit.
`reactor.core.publisher.Mono<Void>`
`afterCompletion(int status)`
Invoked after transaction commit/rollback.
`reactor.core.publisher.Mono<Void>`
`beforeCommit(boolean readOnly)`
Invoked before transaction commit (before "beforeCompletion").
`reactor.core.publisher.Mono<Void>`
`beforeCompletion()`
Invoked before transaction commit/rollback.
`protected reactor.core.publisher.Mono<Void>`
`cleanupResource(O resourceHolder, K resourceKey, boolean committed)`
Perform a cleanup on the given resource (which is left bound to the thread).
`protected reactor.core.publisher.Mono<Void>`
`processResourceAfterCommit(O resourceHolder)`
After-commit callback for the given resource holder.
`protected reactor.core.publisher.Mono<Void>`
`releaseResource(O resourceHolder, K resourceKey)`
Release the given resource (after it has been unbound from the thread).
`reactor.core.publisher.Mono<Void>`
`resume()`
Resume this synchronization.
`protected boolean`
`shouldReleaseAfterCompletion(O resourceHolder)`
Return whether this holder's resource should be released after transaction completion (`true`).
`protected boolean`
`shouldReleaseBeforeCompletion()`
Return whether this holder's resource should be released before transaction completion (`true`) or rather after transaction completion (`false`).
`protected boolean`
`shouldUnbindAtCompletion()`
Return whether this holder should be unbound at completion (or should rather be left bound to the thread after the transaction).
`reactor.core.publisher.Mono<Void>`
`suspend()`
Suspend this synchronization.

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Constructor Details

### ReactiveResourceSynchronization

public ReactiveResourceSynchronization(O resourceObject, K resourceKey, TransactionSynchronizationManager synchronizationManager)
Create a new ReactiveResourceSynchronization for the given holder.

Parameters:
  `resourceObject` - the resource object to manage
  `resourceKey` - the key to bind the resource object for
  `synchronizationManager` - the synchronization manager bound to the current transaction
See Also:
  - `TransactionSynchronizationManager.bindResource(java.lang.Object, java.lang.Object)`

## Method Details

### suspend

public reactor.core.publisher.Mono<Void> suspend()
Description copied from interface: `TransactionSynchronization`
Suspend this synchronization. Supposed to unbind resources from TransactionSynchronizationManager if managing any.

Specified by:
  `suspend` in interface `TransactionSynchronization`
See Also:
  - `TransactionSynchronizationManager.unbindResource(java.lang.Object)`

### resume

public reactor.core.publisher.Mono<Void> resume()
Description copied from interface: `TransactionSynchronization`
Resume this synchronization. Supposed to rebind resources to TransactionSynchronizationManager if managing any.

Specified by:
  `resume` in interface `TransactionSynchronization`
See Also:
  - `TransactionSynchronizationManager.bindResource(java.lang.Object, java.lang.Object)`

### beforeCommit

public reactor.core.publisher.Mono<Void> beforeCommit(boolean readOnly)
Description copied from interface: `TransactionSynchronization`
Invoked before transaction commit (before "beforeCompletion").

This callback does not mean that the transaction will actually be committed. A rollback decision can still occur after this method has been called. This callback is rather meant to perform work that's only relevant if a commit still has a chance to happen, such as flushing SQL statements to the database.

Note that exceptions will get propagated to the commit caller and cause a rollback of the transaction.

Specified by:
  `beforeCommit` in interface `TransactionSynchronization`
Parameters:
  `readOnly` - whether the transaction is defined as read-only transaction
See Also:
  - `TransactionSynchronization.beforeCompletion()`

### beforeCompletion

public reactor.core.publisher.Mono<Void> beforeCompletion()
Description copied from interface: `TransactionSynchronization`
Invoked before transaction commit/rollback. Can perform resource cleanup before transaction completion.

This method will be invoked after `beforeCommit`, even when `beforeCommit` threw an exception. This callback allows for closing resources before transaction completion, for any outcome.

Specified by:
  `beforeCompletion` in interface `TransactionSynchronization`
See Also:
  - `TransactionSynchronization.beforeCommit(boolean)`
  - `TransactionSynchronization.afterCompletion(int)`

### afterCommit

public reactor.core.publisher.Mono<Void> afterCommit()
Description copied from interface: `TransactionSynchronization`
Invoked after transaction commit. Can perform further operations right after the main transaction has successfully committed.

Can, for example, commit further operations that are supposed to follow on a successful commit of the main transaction, like confirmation messages or emails.

NOTE: The transaction will have been committed already, but the transactional resources might still be active and accessible. As a consequence, any data access code triggered at this point will still "participate" in the original transaction, allowing to perform some cleanup (with no commit following anymore!), unless it explicitly declares that it needs to run in a separate transaction. Hence: Use `PROPAGATION_REQUIRES_NEW` for any transactional operation that is called from here.

Specified by:
  `afterCommit` in interface `TransactionSynchronization`

### afterCompletion

public reactor.core.publisher.Mono<Void> afterCompletion(int status)
Description copied from interface: `TransactionSynchronization`
Invoked after transaction commit/rollback. Can perform resource cleanup after transaction completion.

NOTE: The transaction will have been committed or rolled back already, but the transactional resources might still be active and accessible. As a consequence, any data access code triggered at this point will still "participate" in the original transaction, allowing to perform some cleanup (with no commit following anymore!), unless it explicitly declares that it needs to run in a separate transaction. Hence: Use `PROPAGATION_REQUIRES_NEW` for any transactional operation that is called from here.

Specified by:
  `afterCompletion` in interface `TransactionSynchronization`
Parameters:
  `status` - completion status according to the `STATUS_*` constants
See Also:
  - `TransactionSynchronization.STATUS_COMMITTED`
  - `TransactionSynchronization.STATUS_ROLLED_BACK`
  - `TransactionSynchronization.STATUS_UNKNOWN`
  - `TransactionSynchronization.beforeCompletion()`

### shouldUnbindAtCompletion

protected boolean shouldUnbindAtCompletion()
Return whether this holder should be unbound at completion (or should rather be left bound to the thread after the transaction).

The default implementation returns `true`.

### shouldReleaseBeforeCompletion

protected boolean shouldReleaseBeforeCompletion()
Return whether this holder's resource should be released before transaction completion (`true`) or rather after transaction completion (`false`).

Note that resources will only be released when they are unbound from the thread (`shouldUnbindAtCompletion()`).

The default implementation returns `true`.

See Also:
  - `releaseResource(O, K)`

### shouldReleaseAfterCompletion

protected boolean shouldReleaseAfterCompletion(O resourceHolder)
Return whether this holder's resource should be released after transaction completion (`true`).

The default implementation returns `!shouldReleaseBeforeCompletion()`, releasing after completion if no attempt was made before completion.

See Also:
  - `releaseResource(O, K)`

### processResourceAfterCommit

protected reactor.core.publisher.Mono<Void> processResourceAfterCommit(O resourceHolder)
After-commit callback for the given resource holder. Only called when the resource hasn't been released yet (`shouldReleaseBeforeCompletion()`).

Parameters:
  `resourceHolder` - the resource holder to process

### releaseResource

protected reactor.core.publisher.Mono<Void> releaseResource(O resourceHolder, K resourceKey)
Release the given resource (after it has been unbound from the thread).

Parameters:
  `resourceHolder` - the resource holder to process
  `resourceKey` - the key that the resource object was bound for

### cleanupResource

protected reactor.core.publisher.Mono<Void> cleanupResource(O resourceHolder, K resourceKey, boolean committed)
Perform a cleanup on the given resource (which is left bound to the thread).

Parameters:
  `resourceHolder` - the resource holder to process
  `resourceKey` - the key that the resource object was bound for
  `committed` - whether the transaction has committed (`true`) or rolled back (`false`)